## instead 3.5.0

=== CMakeLists.txt ===
PROJECT(instead)

CMAKE_MINIMUM_REQUIRED(VERSION 2.6.0)
SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

IF("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
	MESSAGE(FATAL_ERROR "In-source builds are not allowed. Please read ./INSTALL")
ENDIF("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")

# global constants
SET(INSTEAD_VERSION "3.5.0")

# options
OPTION(WITH_GTK2 "Use GTK2 file open dialog" OFF)
OPTION(WITH_GTK3 "Use GTK3 file open dialog" ON)
OPTION(WITH_ICONV "Build with iconv support" ON)
OPTION(WITH_LUAJIT "Use LuaJIT instead of Lua" ON)
OPTION(WITH_HARFBUZZ "Build with HarfBuzz for RTL language support" OFF)

# Note: there are three build modes for instead:
# - SYSTEMWIDE
#     use it if you want to install it into your (unix) system
# - STANDALONE
#     used to generate standalone relocatable package which
#     may be run from anywhere. `install' target stages all
#     required files in ${STANDALONEDIR} for you
# - neither (both options disabled)
#     instead may be run from build directory, useful for
#     development
OPTION(SYSTEMWIDE "Build for systemwide install" ON)
OPTION(STANDALONE "Build for standalone package creation" OFF)
OPTION(APPIMAGE "Build for appimage package creation" OFF)

IF(WITH_GTK2 AND WITH_GTK3)
	MESSAGE(WARNING "WITH_GTK2 and WITH_GTK3 are mutually exclusive, disabling WITH_GTK2")
	SET(WITH_GTK2 OFF)
ENDIF(WITH_GTK2 AND WITH_GTK3)

IF(SYSTEMWIDE AND STANDALONE)
	MESSAGE(WARNING "Both STANDALONE and SYSTEMWIDE specified, disabling SYSTEMWIDE")
	SET(SYSTEMWIDE OFF)
ENDIF(SYSTEMWIDE AND STANDALONE)

IF(APPIMAGE)
SET(CMAKE_INSTALL_PREFIX "/usr")
ENDIF(APPIMAGE)

SET(BINDIR "bin" CACHE STRING "Where to install binaries")
SET(DATADIR "share/instead" CACHE STRING "Where to install data files")
SET(STEADDIR "${DATADIR}/stead" CACHE STRING "Where to install stead files")
SET(THEMESDIR "${DATADIR}/themes" CACHE STRING "Where to install themes")
SET(GAMESDIR "${DATADIR}/games" CACHE STRING "Where to install games")
SET(ICONDIR "share/pixmaps" CACHE STRING "Where to install icons")
SET(DOCDIR "share/doc/instead" CACHE STRING "Where to install documentation")
SET(LANGDIR "${DATADIR}/lang" CACHE STRING "Where to install language files")
SET(MANDIR "share/man" CACHE STRING "Where to install man pages")
SET(DESKTOPDIR "share/applications" CACHE STRING "Where to install .desktop files")

SET(STANDALONEDIR "${PROJECT_BINARY_DIR}/standalone" CACHE STRING "Where to stage stanalone package")

# subdirectories
ADD_SUBDIRECTORY(desktop)
ADD_SUBDIRECTORY(doc)
ADD_SUBDIRECTORY(games)
ADD_SUBDIRECTORY(icon)
ADD_SUBDIRECTORY(lang)
ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(stead)
ADD_SUBDIRECTORY(themes)

=== Makefile ===
include Rules.make
include config.make

VERTITLE := instead-$(VERSION)
ARCHIVE := instead_$(VERSION).tar.gz#

SUBDIRS += src/ stead games themes icon desktop doc lang

all:
	@for dir in $(SUBDIRS); do \
		$(MAKE) -C $$dir $(@) || exit 1; \
	done;

Rules.make:
	ln -sf Rules.make.standalone Rules.make

config.make:
	echo "# you can define own flags here" > config.make

svnclean:
	{ test -d .svn && svn st; } | grep "^?" | awk '{ print $$2 }' | grep -v "config.make" | while read l; do $(RM) -rf $$l; done

gitclean:
	{ test -d .git && git status -s; } | grep "^??" | awk '{ print $$2 }' | grep -v "config.make" | while read l; do $(RM) -rf $$l; done

rules:
	$(RM) -f Rules.make
	ln -sf Rules.make.standalone Rules.make

docs: rules
	make docs -C doc/

PKGBUILD: PKGBUILD.in tarball
	cat PKGBUILD.in | sed -e s/MD5SUM/`md5sum $(ARCHIVE) | cut -f1 -d' '`/g > PKGBUILD

windows-sdl2.tar.gz:
	wget "http://sourceforge.net/projects/instead/files/instead/build-bin-data/windows-sdl2-2.0.24.tar.gz/download" -O $(@)
	# wget "http://sourceforge.net/projects/instead/files/instead/build-bin-data/windows-sdl2-2.0.22.tar.gz/download" -O $(@)
	# wget "http://sourceforge.net/projects/instead/files/instead/build-bin-data/windows-sdl2-2.0.14.tar.gz/download" -O $(@)

build-bin-data: windows-sdl2.tar.gz

tarball: clean svnclean gitclean docs rules
	echo "# you can define own flags here" > config.make
	ln -sf ./ $(VERTITLE)
	tar -cz --exclude $(VERTITLE)/$(VERTITLE) --exclude CJK.zip --exclude .git --exclude .svn --exclude $(ARCHIVE) --exclude windows-sdl2.tar.gz -f $(ARCHIVE) $(VERTITLE)/*
	$(RM) -f $(VERTITLE)

clean:
	@for dir in $(SUBDIRS); do \
		$(MAKE) clean -C $$dir $(@) || exit 1; \
	done;
	$(RM) -f $(ARCHIVE)
	$(RM) -f PKGBUILD

install: all
ifeq ($(SYSTEMSETUP), yes)
	@for dir in $(SUBDIRS); do \
		$(MAKE) -C $$dir install || exit 1; \
	done;
else
	echo No install needed
endif

uninstall:
ifeq ($(SYSTEMSETUP), yes)
	@for dir in $(SUBDIRS); do \
		$(MAKE) -C $$dir uninstall || exit 1; \
	done;
	$(RM) -rf $(STEADPATH)
else
	echo No uninstall needed
endif

=== debian/changelog ===
instead (3.5.0) unstable; urgency=low
  * 3.5.0 release;

 -- Peter Kosyh <pkosyh@yandex.ru>  Sat, 27 Aug 2022 11:07:00 +0300

instead (3.4.1) unstable; urgency=low
  * 3.4.1 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Wed, 08 Sep 2021 21:33:00 +0300

instead (3.4.0) unstable; urgency=low
  * 3.4.0 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Tue, 31 Sep 2021 12:38:00 +0300

instead (3.3.4) unstable; urgency=low
  * 3.3.4 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Wed, 24 Mar 2021 09:11:00 +0300

instead (3.3.3) unstable; urgency=low
  * 3.3.3 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Wed, 20 Jan 2021 16:00:00 +0300

instead (3.3.2) unstable; urgency=low
  * 3.3.2 build fix release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Sun, 19 Apr 2020 11:00:00 +0300

instead (3.3.1) unstable; urgency=low
  * 3.3.1 build fix release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Fri, 4 Oct 2019 18:21:00 +0300

instead (3.3.0) unstable; urgency=low
  * 3.3.0 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Fri, 8 Mar 2019 09:28:00 +0300

instead (3.2.2) unstable; urgency=low
  * 3.2.2 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Sat, 1 Sep 2018 09:21:00 +0300

instead (3.2.1) unstable; urgency=low
  * 3.2.1 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Sun, 22 Apr 2018 13:34:00 +0300

instead (3.2.0) unstable; urgency=low
  * 3.2.0 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Fri, 9 Feb 2018 21:07:00 +0300

instead (3.1.2) unstable; urgency=low
  * 3.1.2 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Mon, 21 Aug 2017 16:45:00 +0300

instead (3.1.1) unstable; urgency=low
  * 3.1.1 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Mon, 21 Aug 2017 08:50:00 +0300

instead (3.1.0) unstable; urgency=low
  * 3.1.0 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Sun, 20 Aug 2017 10:16:00 +0300

instead (3.0.1) unstable; urgency=low
  * 3.0.1 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Wed, 24 May 2017 21:03:00 +0300

instead (3.0.0) unstable; urgency=low
  * 3.0.0 release;

 -- Peter Kosyh <p.kosyh@gmail.com>  Wed, 19 Apr 2017 17:45:00 +0300

## instead 3.5.2%2Bdfsg

=== Makefile ===
--- 
+++ 
@@ -34,7 +34,8 @@
 	cat PKGBUILD.in | sed -e s/MD5SUM/`md5sum $(ARCHIVE) | cut -f1 -d' '`/g > PKGBUILD
 
 windows-sdl2.tar.gz:
-	wget "http://sourceforge.net/projects/instead/files/instead/build-bin-data/windows-sdl2-2.0.24.tar.gz/download" -O $(@)
+	wget "http://sourceforge.net/projects/instead/files/instead/build-bin-data/windows-sdl2-2.0.24.2.tar.gz/download" -O $(@)
+	# wget "http://sourceforge.net/projects/instead/files/instead/build-bin-data/windows-sdl2-2.0.24.tar.gz/download" -O $(@)
 	# wget "http://sourceforge.net/projects/instead/files/instead/build-bin-data/windows-sdl2-2.0.22.tar.gz/download" -O $(@)
 	# wget "http://sourceforge.net/projects/instead/files/instead/build-bin-data/windows-sdl2-2.0.14.tar.gz/download" -O $(@)

## instead 3.5.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 ENDIF("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
 
 # global constants
-SET(INSTEAD_VERSION "3.5.0")
+SET(INSTEAD_VERSION "3.5.2")
 
 # options
 OPTION(WITH_GTK2 "Use GTK2 file open dialog" OFF)

=== desktop/CMakeLists.txt ===
IF(SYSTEMWIDE)
	SET(BIN ${CMAKE_INSTALL_PREFIX}/${BINDIR}) # for following CONFIGURE_FILE
	CONFIGURE_FILE(instead.desktop.in instead.desktop)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/instead.desktop DESTINATION ${DESKTOPDIR})
ENDIF(SYSTEMWIDE)

=== games/CMakeLists.txt ===
SET(GAMES tutorial)

IF(SYSTEMWIDE)
	FOREACH(GAME ${GAMES})
		INSTALL(DIRECTORY ${GAME} DESTINATION ${GAMESDIR} PATTERN ".svn" EXCLUDE)
	ENDFOREACH(GAME)
ELSEIF(STANDALONE)
	FOREACH(GAME ${GAMES})
		INSTALL(DIRECTORY ${GAME} DESTINATION ${STANDALONEDIR}/games PATTERN ".svn" EXCLUDE)
	ENDFOREACH(GAME)
ENDIF(SYSTEMWIDE)

=== games/Makefile ===
include ../Rules.make
include ../config.make

all:
install:
	$(INSTALLD) $(DESTDIR)$(GAMESPATH)
	for f in *; do \
		echo $$f;\
		if [ ! -d $$f ]; then continue; fi;\
		$(INSTALLD) $(DESTDIR)$(GAMESPATH)/$$f; \
		tar --exclude=".svn" -cf - -C $$f . | tar -xpf - -C $(DESTDIR)$(GAMESPATH)/$$f;\
	done

uninstall:
	$(RM) -rf $(DESTDIR)$(GAMESPATH)

clean:

=== src/CMakeLists.txt ===
# sources
SET(INSTEAD_SRCS
	SDL_gif.c
	SDL_gfxBlitFunc.c
	SDL_rotozoom.c
	config.c
	game.c
	graphics.c
	input.c
	noise1234.c
	ioapi.c
	main.c
	menu.c
	sound.c
	themes.c
	unpack.c
	unzip.c
	utils.c
	instead_bits.c
	instead_sprites.c
	instead_timer.c
	instead_sound.c
	instead_paths.c
	instead/instead.c
	instead/util.c
	instead/list.c
	instead/cache.c
	instead/idf.c
	instead/tinymt32.c
	instead/lfs.c
)

# platform-specific sources
IF(APPLE)
	SET(INSTEAD_SRCS ${INSTEAD_SRCS} macosx.m)
	ADD_DEFINITIONS(-Dunix)
ELSEIF(WIN32)
	SET(INSTEAD_SRCS ${INSTEAD_SRCS} windows.c iowin32.c)
ELSEIF(UNIX)
	SET(INSTEAD_SRCS ${INSTEAD_SRCS} unix.c)
	ADD_DEFINITIONS(-Dunix)
ELSE(APPLE)
	MESSAGE(FATAL_ERROR "Your platform is not supported yet, sorry")
ENDIF(APPLE)

# flags
ADD_DEFINITIONS(
	-DVERSION=\"${INSTEAD_VERSION}\"
	-D_USE_UNPACK
	-Wall
	-D_USE_SDL
)

INCLUDE(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-Wextra WEXTRA_FLAG_SUPPORTED)
CHECK_CXX_COMPILER_FLAG(-Wno-unused-parameter WNO_UNUSED_PARAMETER_FLAG_SUPPORTED)

IF(WEXTRA_FLAG_SUPPORTED)
	ADD_DEFINITIONS(-Wextra)
ENDIF(WEXTRA_FLAG_SUPPORTED)

IF(WNO_UNUSED_PARAMETER_FLAG_SUPPORTED)
	ADD_DEFINITIONS(-Wno-unused-parameter)
ENDIF(WNO_UNUSED_PARAMETER_FLAG_SUPPORTED)

IF(APPIMAGE)
	ADD_DEFINITIONS(-DAPPIMAGE)
ENDIF(APPIMAGE)

IF(SYSTEMWIDE)
	if(APPIMAGE)
		ADD_DEFINITIONS(
			-DLANG_PATH=\"usr/${LANGDIR}/\"
			-DSTEAD_PATH=\"usr/${STEADDIR}/\"
			-DGAMES_PATH=\"usr/${GAMESDIR}/\"
			-DTHEMES_PATH=\"usr/${THEMESDIR}/\"
			-DICON_PATH=\"usr/${ICONDIR}/\"
		)
	ELSE(APPIMAGE)
		# Systemwide installation, global data paths
		ADD_DEFINITIONS(
			-DLANG_PATH=\"${CMAKE_INSTALL_PREFIX}/${LANGDIR}/\"
			-DSTEAD_PATH=\"${CMAKE_INSTALL_PREFIX}/${STEADDIR}/\"
			-DGAMES_PATH=\"${CMAKE_INSTALL_PREFIX}/${GAMESDIR}/\"
			-DTHEMES_PATH=\"${CMAKE_INSTALL_PREFIX}/${THEMESDIR}/\"
			-DICON_PATH=\"${CMAKE_INSTALL_PREFIX}/${ICONDIR}/\"
		)
	ENDIF(APPIMAGE)
ELSEIF(STANDALONE)
	# Standalone installation, local data paths
	ADD_DEFINITIONS(
		-DLANG_PATH=\"lang/\"
		-DSTEAD_PATH=\"stead/\"
		-DGAMES_PATH=\"games/\"
		-DTHEMES_PATH=\"themes/\"
		-DICON_PATH=\"icon/\"
		-D_LOCAL_APPDATA
	)
ELSE(SYSTEMWIDE)
	# Neither, data paths point to source tree
	ADD_DEFINITIONS(
		-DLANG_PATH=\"${CMAKE_SOURCE_DIR}/lang/\"
		-DSTEAD_PATH=\"${CMAKE_SOURCE_DIR}/stead/\"
		-DGAMES_PATH=\"${CMAKE_SOURCE_DIR}/games/\"
		-DTHEMES_PATH=\"${CMAKE_SOURCE_DIR}/themes/\"
		-DICON_PATH=\"${CMAKE_SOURCE_DIR}/icon/\"
	)
ENDIF(SYSTEMWIDE)

# depends
IF(WITH_LUAJIT)
FIND_PACKAGE(LuaJIT REQUIRED)
ELSE(WITH_LUAJIT)
FIND_PACKAGE(Lua51 REQUIRED)
ENDif(WITH_LUAJIT)

FIND_PACKAGE(ZLIB REQUIRED)
FIND_LIBRARY(MATH_LIBRARY m)

INCLUDE_DIRECTORIES(
	${ZLIB_INCLUDE_DIRS}
	${LUA_INCLUDE_DIR}
)

SET(INSTEAD_LIBS
	${ZLIB_LIBRARIES}
	${LUA_LIBRARIES}
	${MATH_LIBRARY}
)

IF(APPLE)
	SET(INSTEAD_LIBS ${INSTEAD_LIBS} "-framework AppKit")
ENDIF(APPLE)

FIND_PACKAGE(SDL2 REQUIRED)
FIND_PACKAGE(SDL2_mixer REQUIRED)
FIND_PACKAGE(SDL2_image REQUIRED)
FIND_PACKAGE(SDL2_ttf REQUIRED)

INCLUDE_DIRECTORIES(
	${SDL2_INCLUDE_DIR}
	${SDL2MIXER_INCLUDE_DIR}
	${SDL2IMAGE_INCLUDE_DIR}
	${SDL2TTF_INCLUDE_DIR}
)

LIST(APPEND INSTEAD_LIBS
	${SDL2_LIBRARY}
	${SDL2MIXER_LIBRARY}
	${SDL2IMAGE_LIBRARY}
	${SDL2TTF_LIBRARY}
)

IF(WITH_ICONV)
	FIND_PACKAGE(Iconv REQUIRED)
	ADD_DEFINITIONS(-D_HAVE_ICONV)
	INCLUDE_DIRECTORIES(${ICONV_INCLUDE_DIR})
	SET(INSTEAD_LIBS ${INSTEAD_LIBS} ${ICONV_LIBRARY})
ENDIF(WITH_ICONV)

IF(WITH_GTK2)
	FIND_PACKAGE(GTK2 REQUIRED)
	ADD_DEFINITIONS(-D_USE_GTK -D_USE_BROWSE ${GTK2_DEFINITIONS})
	INCLUDE_DIRECTORIES(${GTK2_INCLUDE_DIRS})
	SET(INSTEAD_LIBS ${INSTEAD_LIBS} ${GTK2_LIBRARIES})
ELSEIF(WITH_GTK3)
	FIND_PACKAGE(GTK3 REQUIRED)
	ADD_DEFINITIONS(-D_USE_GTK -D_USE_BROWSE)
	INCLUDE_DIRECTORIES(${GTK3_INCLUDE_DIRS})
	SET(INSTEAD_LIBS ${INSTEAD_LIBS} ${GTK3_LIBRARIES})
ENDIF(WITH_GTK2)

IF(WITH_HARFBUZZ)
	FIND_PACKAGE(HarfBuzz REQUIRED)
	ADD_DEFINITIONS(-D_USE_HARFBUZZ ${HARFBUZZ_DEFINITIONS})
	INCLUDE_DIRECTORIES(${HARFBUZZ_INCLUDE_DIR})
	SET(INSTEAD_LIBS ${INSTEAD_LIBS} ${HARFBUZZ_LIBRARY})
	FIND_PACKAGE(PkgConfig REQUIRED)
ENDIF(WITH_HARFBUZZ)

IF(WITH_HARFBUZZ AND NOT WITH_GTK3)
	FIND_PACKAGE(GLIB REQUIRED)
	ADD_DEFINITIONS(${GLIB_DEFINITIONS})
	INCLUDE_DIRECTORIES(${GLIB_INCLUDE_DIRS})
	SET(INSTEAD_LIBS ${INSTEAD_LIBS} ${GLIB_LIBRARIES})
	FIND_PACKAGE(PkgConfig REQUIRED)
ENDIF(WITH_HARFBUZZ AND NOT WITH_GTK3)

# targets
ADD_EXECUTABLE(sdl-instead ${INSTEAD_SRCS})
TARGET_LINK_LIBRARIES(sdl-instead ${INSTEAD_LIBS})

# install
INCLUDE(InstallSymlink)

IF(SYSTEMWIDE)
	INSTALL(TARGETS sdl-instead DESTINATION ${BINDIR})
	INSTALL_SYMLINK(sdl-instead instead${CMAKE_EXECUTABLE_SUFFIX} ${BINDIR})
ELSEIF(STANDALONE)
	INSTALL(TARGETS sdl-instead DESTINATION ${STANDALONEDIR})
	INSTALL_SYMLINK(sdl-instead instead${CMAKE_EXECUTABLE_SUFFIX} ${STANDALONEDIR})
ENDIF(SYSTEMWIDE)

=== src/Makefile ===
include ../Rules.make
include ../config.make

CFLAGS += $(SDL_CFLAGS) $(LUA_CFLAGS) $(ZLIB_CFLAGS) $(EXTRA_CFLAGS)  -D_USE_SDL -DLANG_PATH=\"${LANGPATH}/\" -DSTEAD_PATH=\"${STEADPATH}/\"  -DGAMES_PATH=\"${GAMESPATH}/\" -DTHEMES_PATH=\"${THEMESPATH}/\" -DVERSION=\"$(VERSION)\" -DICON_PATH=\"${ICONPATH}/\"

LDFLAGS += $(SDL_LFLAGS) $(LUA_LFLAGS) $(ZLIB_LFLAGS) $(EXTRA_LDFLAGS)

INSTEAD_SRC	:= instead/instead.c instead/util.c instead/list.c instead/cache.c instead/idf.c instead/tinymt32.c instead/lfs.c
INSTEAD_H	:= instead/cache.h instead/system.h instead/instead.h instead/list.h instead/util.h instead/tinymt32.h instead/idf.h

SRC     := graphics.c input.c game.c main.c \
	instead_bits.c instead_sprites.c instead_timer.c instead_sound.c instead_paths.c noise1234.c \
	sound.c SDL_rotozoom.c SDL_gfxBlitFunc.c SDL_gif.c config.c themes.c menu.c \
	utils.c unzip.c ioapi.c unpack.c $(PLATFORM) $(INSTEAD_SRC)

H	:= config.h externals.h game.h graphics.h input.h internals.h ioapi.h iowin32.h \
	menu.h SDL_rotozoom.h SDL_gif.h SDL_gfxBlitFunc.h sound.h themes.h unzip.h $(INSTEAD_H)

OBJ     := $(patsubst %.c, %.o, $(SRC)) $(ADDOBJ)

all: sdl-instead$(EXE)

$(OBJ): %.o : %.c $(H)
	$(CC) -c $(<) $(I) $(CFLAGS) $(CPPFLAGS) -o $(@)

sdl-instead$(EXE):  $(OBJ) $(RESOURCES)
	$(CC) $(CFLAGS) $(^) $(LDFLAGS) -o $(@) 

install:
	$(INSTALLD) $(DESTDIR)$(BIN)
	$(INSTALLB) sdl-instead$(EXE) $(DESTDIR)$(BIN)/sdl-instead$(EXE)
	$(LN) sdl-instead$(EXE) $(DESTDIR)$(BIN)/instead$(EXE)

uninstall:
	$(RM) $(DESTDIR)$(BIN)/sdl-instead$(EXE)
	$(RM) $(DESTDIR)$(BIN)/instead$(EXE)

clean:
	$(RM) -f *.o instead/*.o sdl-instead$(EXE)

=== stead/CMakeLists.txt ===
ADD_SUBDIRECTORY(stead2)
ADD_SUBDIRECTORY(stead3)

=== stead/Makefile ===
include ../Rules.make
include ../config.make

clean:
all:	stead2/stead.lua stead3/stead.lua

install:
	$(INSTALLD) $(DESTDIR)$(STEADPATH)

	for api in stead2 stead3; do \
		$(INSTALLD) $(DESTDIR)$(STEADPATH)/$$api; \
		$(INSTALLD) $(DESTDIR)$(STEADPATH)/$$api/ext; \
		for f in $$api/*.lua; do \
			$(INSTALL) $$f $(DESTDIR)$(STEADPATH)/$$f || exit 1; \
		done; \
		for f in $$api/ext/*.lua; do \
			$(INSTALL) $$f $(DESTDIR)$(STEADPATH)/$$f || exit 1; \
		done; \
	done

uninstall:

=== themes/Makefile ===
include ../Rules.make
include ../config.make

clean:
all:
install:
	$(INSTALLD) $(DESTDIR)$(THEMESPATH)
	for f in *; do \
		if [ ! -d $$f ]; then continue; fi;\
		$(INSTALLD) $(DESTDIR)$(THEMESPATH)/$$f;\
		tar --exclude=".svn" -cf - -C $$f . | tar -xpf - -C $(DESTDIR)$(THEMESPATH)/$$f;\
	done

uninstall:
	$(RM) -rf $(DESTDIR)$(THEMESPATH)

=== src/tiny/Makefile ===
include ../../Rules.make.standalone
include ../../config.make

CFLAGS += $(LUA_CFLAGS) $(EXTRA_CFLAGS) -DSTEAD_PATH=\"${STEADPATH}/\" -DVERSION=\"$(VERSION)\"

LDFLAGS += $(LUA_LFLAGS) $(EXTRA_LDFLAGS)

INSTEAD_SRC	:= instead.c util.c list.c cache.c idf.c tinymt32.c lfs.c

SRC     := $(INSTEAD_SRC)
OBJ     := $(patsubst %.c, %.o, $(SRC))

all: instead stead tiny-instead$(EXE) tiny-mp$(EXE)

$(OBJ): %.o : instead/%.c
	$(CC) -c $(<) $(I) $(CFLAGS) $(CPPFLAGS) -o $(@)

tiny-instead$(EXE): main.c $(OBJ)
	$(CC) $(CFLAGS) $(^) $(LDFLAGS) -o $(@)

tiny-mp$(EXE): metaparser.c $(OBJ)
	$(CC) $(CFLAGS) $(^) $(LDFLAGS) -o $(@)

instead:
	ln -s ../instead instead

stead:
	ln -s ../../stead stead

clean:
	$(RM) -f *.o instead stead tiny-instead$(EXE) tiny-mp$(EXE)

=== stead/stead2/CMakeLists.txt ===
FILE(GLOB STEAD_FILES "*.lua")
FILE(GLOB STEAD_EXT_FILES "ext/*.lua")

IF(SYSTEMWIDE)
	INSTALL(FILES ${STEAD_FILES} DESTINATION ${STEADDIR}/stead2)
	INSTALL(FILES ${STEAD_EXT_FILES} DESTINATION ${STEADDIR}/stead2/ext)
ELSEIF(STANDALONE)
	INSTALL(FILES ${STEAD_FILES} DESTINATION ${STANDALONEDIR}/stead/stead2)
	INSTALL(FILES ${STEAD_EXT_FILES} DESTINATION ${STANDALONEDIR}/stead/stead2/ext)
ENDIF(SYSTEMWIDE)

=== debian/changelog ===
instead (3.5.2+dfsg-0.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1113044)

 -- Adrian Bunk <bunk@debian.org>  Sat, 11 Oct 2025 20:13:29 +0300

instead (3.5.2+dfsg-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * enable building with libluajit5.1 for riscv64 and loong64 archs

  [ Alexandre Detiste ]
  * remove unused local copy of zlib

 -- Anatoliy Gunya <csm.sub21@gmail.com>  Tue, 31 Dec 2024 21:20:10 +0300

instead (3.5.2+dfsg-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release (Closes: #1072548).
  * debian/compat: delete it.
  * debian/control:
    - Bump Standards-Version up to 4.7.0.
    - Refresh build dependencies:
      - use debhelper-compat (= 13) instead of debhelper;
      - use libluajit5.1 for supported arches;
      - build with libharfbuzz.
  * debian/copyrigh:
    - describe excluded files;
    - update years;
    - remove unneeded license texts.
  * debian/rules: update build options.
  * debian/watch: repack orig to exclude unneeded files.

 -- Anatoliy Gunya <csm.sub21@gmail.com>  Thu, 26 Sep 2024 02:48:38 +0300

=== debian/control ===
Source: instead
Section: games
Priority: optional
Maintainer: Sam Protsenko <joe.skb7@gmail.com>
Build-Depends:
 debhelper-compat (= 13),
 dpkg-dev (>= 1.16.1~),
 pkgconf,
 cmake (>= 2.6.0),
 zlib1g-dev,
 libgtk-3-dev,
 libharfbuzz-dev,
 libluajit-5.1-dev [amd64 arm64 armel armhf i386 mips64el mipsel s390x powerpc riscv64 loong64],
 liblua5.1-0-dev [!amd64 !arm64 !armel !armhf !i386 !mips64el !mipsel !s390x !powerpc !riscv64 !loong64],
 libsdl2-dev,
 libsdl2-image-dev,
 libsdl2-mixer-dev,
 libsdl2-ttf-dev,
Standards-Version: 4.7.0
Homepage: https://instead-hub.github.io/
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/games-team/instead.git
Vcs-Browser: https://salsa.debian.org/games-team/instead

Package: instead
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, instead-data (= ${source:Version})
Suggests: instead-doc-en | instead-doc-ru
Description: Simple text adventures/visual novels engine
 INSTEAD -- INterpreter of Simple TExt ADventure.
 Using INSTEAD you can create and play games that could be classified
 as a mix of visual novel and text quest.
 .
 Features:
   * Simple story source code (Lua-based script)
   * GUI interface that supports music and pictures
   * Theme support
   * Portability (INSTEAD depends on SDL and Lua)
 .
 Game repository: https://instead-hub.github.io/page/games/

Package: instead-data
Architecture: all
Depends: ${misc:Depends}, fonts-liberation
Recommends: instead
Description: Data files for INSTEAD
 INSTEAD -- INterpreter of Simple TExt ADventure.
 Using INSTEAD you can create and play games that could be classified
 as a mix of visual novel and text quest.
 .
 Features:
   * Simple story source code (Lua-based script)
   * GUI interface that supports music and pictures
   * Theme support
   * Portability (INSTEAD depends on SDL and Lua)
 .
 This package contains language files, graphical themes, STEAD scripts
 and tutorial.

Package: instead-doc-common
Section: doc
Architecture: all
Depends: ${misc:Depends}
Replaces: instead-doc-base
Conflicts: instead-doc-base
Description: Common documentation for INSTEAD
 This package contains base documentation (common for all languages).
 .
 At the moment this contains only examples for developer's manual.
 These examples (written in Lua) demonstrate how to implement
 common features when you write a game for INSTEAD.

Package: instead-doc-en
Section: doc
Architecture: all
Depends: ${misc:Depends}, instead-doc-common (= ${source:Version})
Description: English documentation for INSTEAD
 This package contains game developer manual and examples in English.
 Manual describes basic API in Lua and how to create games for INSTEAD engine.
 .
 Complete and latest documentation is only available in Russian, and even
 though its English counterpart is being translated and maintained, it may lag
 behind a little bit.

Package: instead-doc-ru
Section: doc
Architecture: all
Depends: ${misc:Depends}, instead-doc-common (= ${source:Version})
Description: Russian documentation for INSTEAD
 This package contains game developer manual and examples in Russian.
 Manual describes basic API in Lua and how to create games for INSTEAD engine.
 .
 Russian documentation is complete and up to date, so it's preferred to use it.

=== debian/rules ===
#!/usr/bin/make -f

# Output every command that modifies files on the build system
#export DH_VERBOSE = 1

# Enable all hardening options
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Install INSTEAD to /usr/games rather than to /usr/bin
BINDIR = games
# Put data into /usr/share/games/instead rather than /usr/share/instead
DATADIR = share/games/instead
# Configure CMake build
CMAKE_FLAGS = -DWITH_HARFBUZZ=1
# Use libluajit on supported arches and liblua51 otherwise
ifeq ($(findstring $(DEB_TARGET_ARCH), amd64 arm64 armel armhf i386 mips64el mipsel s390x powerpc riscv64 loong64),)
CMAKE_FLAGS += -DWITH_LUAJIT=0
endif
# Override some variables in CMakeLists.txt
CMAKE_CACHE_FLAGS = -DBINDIR=$(BINDIR) -DDATADIR=$(DATADIR)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS) $(CMAKE_CACHE_FLAGS)

override_dh_compress:
	dh_compress --exclude=.pdf --exclude=.lua

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=4

# qa.debian.org runs a redirector which allows a simpler form of URL
# for SourceForge based projects. The format below will automatically
# be rewritten to use the redirector.
opts="pgpsigurlmangle=s/$/.asc/, dversionmangle=s/\+dfsg//, repacksuffix=+dfsg, compression=xz" http://sf.net/instead/instead_(.+)\.tar\.gz
